/*******************************************************************************
* File Name: Input_voltage.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Input_voltage_H) /* Pins Input_voltage_H */
#define CY_PINS_Input_voltage_H

#include "cytypes.h"
#include "cyfitter.h"
#include "Input_voltage_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Input_voltage_Write(uint8 value) ;
void    Input_voltage_SetDriveMode(uint8 mode) ;
uint8   Input_voltage_ReadDataReg(void) ;
uint8   Input_voltage_Read(void) ;
uint8   Input_voltage_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Input_voltage_DRIVE_MODE_BITS        (3)
#define Input_voltage_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - Input_voltage_DRIVE_MODE_BITS))

#define Input_voltage_DM_ALG_HIZ         (0x00u)
#define Input_voltage_DM_DIG_HIZ         (0x01u)
#define Input_voltage_DM_RES_UP          (0x02u)
#define Input_voltage_DM_RES_DWN         (0x03u)
#define Input_voltage_DM_OD_LO           (0x04u)
#define Input_voltage_DM_OD_HI           (0x05u)
#define Input_voltage_DM_STRONG          (0x06u)
#define Input_voltage_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define Input_voltage_MASK               Input_voltage__MASK
#define Input_voltage_SHIFT              Input_voltage__SHIFT
#define Input_voltage_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Input_voltage_PS                     (* (reg32 *) Input_voltage__PS)
/* Port Configuration */
#define Input_voltage_PC                     (* (reg32 *) Input_voltage__PC)
/* Data Register */
#define Input_voltage_DR                     (* (reg32 *) Input_voltage__DR)
/* Input Buffer Disable Override */
#define Input_voltage_INP_DIS                (* (reg32 *) Input_voltage__PC2)


#if defined(Input_voltage__INTSTAT)  /* Interrupt Registers */

    #define Input_voltage_INTSTAT                (* (reg32 *) Input_voltage__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define Input_voltage_DRIVE_MODE_SHIFT       (0x00u)
#define Input_voltage_DRIVE_MODE_MASK        (0x07u << Input_voltage_DRIVE_MODE_SHIFT)


#endif /* End Pins Input_voltage_H */


/* [] END OF FILE */
