/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>

int encoderPulseCount;
// values defined by the user
int userLubricationPeriod;
int userDesiredLubricationAmount;

void sleep()
{
    CyDelay(userLubricationPeriod);
}

void initializeEncoder(){
    Solenoid_Pin_Write(~Solenoid_Pin_Read());
    Encoder_LED_Pin_Write(~Encoder_LED_Pin_Read());        
}

void shutDownEncoder(){
    Solenoid_Pin_Write(~Solenoid_Pin_Read());
    Encoder_LED_Pin_Write(~Encoder_LED_Pin_Read());
}
int main()
{
    CyGlobalIntEnable; /* Enable global interrupts. */

    userLubricationPeriod = 5000;

    // TODO: create code that turns the lubrication amount into a max encoder pulse count
    userDesiredLubricationAmount = 10;
           
    encoderPulseCount = 0;
    
    uint8 Values;
        
    // wake up, turn on the solenoid and Encoder LED
    initializeEncoder();

    for(;;)
    {
        Values = Encoder_PhotoDiode_Pin_Read();

        if (Encoder_PhotoDiode_Pin_Read()){
            encoderPulseCount++;
        }

        if (Values > 128){
            CyDelay(500);
            shutDownEncoder();
            CyDelay(500);
            shutDownEncoder();
            CyDelay(500);
            shutDownEncoder();
        }
        
        if (encoderPulseCount >= userDesiredLubricationAmount){
            shutDownEncoder();
            encoderPulseCount = 0;
            sleep();
        }
    }
}
/* [] END OF FILE */
